//
//  PSWView.m
//  支付密码
//
//  Created by 丁宗凯 on 16/8/16.
//  Copyright © 2016年 dzk. All rights reserved.
//
#define MAINSCREEN_width   [UIScreen mainScreen].bounds.size.width
#define MAINSCREEN_height  [UIScreen mainScreen].bounds.size.height
#define MAINSCREEN_bounds  [UIScreen mainScreen].bounds
#define WindowFirst        [[[UIApplication sharedApplication] windows] firstObject]
#define pointY             200

#import "PSWView.h"
static PSWView* content_View=nil;
static UIView* BGView=nil;
static QGPassWordTextField*psw_TextField=nil;
@implementation PSWView
+(void)sharePSWView
{
    if (content_View==nil && BGView==nil) {
        content_View = [[PSWView alloc] init];
        BGView = [[UIView alloc] initWithFrame:MAINSCREEN_bounds];
    }
}
+(PSWView*)showPSWView
{
    //创建
    [PSWView sharePSWView];
    //背景
    BGView.backgroundColor = [UIColor blackColor];
    BGView.alpha = 0;
    [WindowFirst addSubview:BGView];
    //内容
    content_View.frame = CGRectMake(0, MAINSCREEN_height, MAINSCREEN_width, MAINSCREEN_height-pointY);
    content_View.backgroundColor = [UIColor whiteColor];
    [WindowFirst addSubview:content_View];
    
    UIView*barView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, MAINSCREEN_width, 40)];
    [content_View addSubview:barView];
    
    UIView*line = [[UIView alloc] initWithFrame:CGRectMake(0, CGRectGetHeight(barView.frame)-0.5, MAINSCREEN_width, 0.5)];
    line.backgroundColor = [UIColor grayColor];
    [barView addSubview:line];
    
    UILabel *titleLab = [[UILabel alloc] initWithFrame:CGRectMake((MAINSCREEN_width -100)/2, 0, 100, 40)];
    titleLab.text = @"请输入密码";
    titleLab.textAlignment = NSTextAlignmentCenter;
    [barView addSubview:titleLab];
    
    UIButton*cancelBtn = [UIButton buttonWithType:UIButtonTypeSystem];
    cancelBtn.frame = CGRectMake(0, 0, 50, 40);
    [cancelBtn setTitle:@"取消" forState:0];
    [cancelBtn addTarget:content_View action:@selector(cancelButtonClick) forControlEvents:UIControlEventTouchUpInside];
    [barView addSubview:cancelBtn];
    
    UIButton*OKBtn = [UIButton buttonWithType:UIButtonTypeSystem];
    OKBtn.frame = CGRectMake(MAINSCREEN_width-50, 0, 50, 40);
    [OKBtn setTitle:@"确定" forState:0];
    [OKBtn addTarget:content_View action:@selector(OKButtonClick) forControlEvents:UIControlEventTouchUpInside];
    [barView addSubview:OKBtn];
    
    psw_TextField = [[QGPassWordTextField alloc] init];
    psw_TextField.passWordCount = 6;
    psw_TextField.secureTextEntry = YES;
    CGFloat pointX = 20;
    CGFloat width =MAINSCREEN_width-pointX*2;
    CGFloat height = width/psw_TextField.passWordCount;
    psw_TextField.frame = CGRectMake(pointX, pointX+CGRectGetMaxY(barView.frame), width, height);
    [psw_TextField becomeFirstResponder];
    [content_View addSubview:psw_TextField];
    
    //动画
    [PSWView show];
    
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:content_View action:@selector(cancelButtonClick)];
    [BGView addGestureRecognizer:tap];
    return content_View;
}
-(void)cancelButtonClick
{
    [PSWView hiden];
}
-(void)OKButtonClick
{
    [PSWView hiden];
    if (content_View.finishActionBlock) {
        content_View.finishActionBlock(psw_TextField.text);
    }
}

+(void)show
{
    [UIView animateWithDuration:0.3 animations:^{
        BGView.alpha = 0.4;
        content_View.frame = CGRectMake(0, pointY, MAINSCREEN_width, MAINSCREEN_height-pointY);
    } completion:^(BOOL finished) {
        
    }];
}
+(void)hiden
{
    
    [UIView animateWithDuration:0.3 animations:^{
        [psw_TextField endEditing:YES];

        BGView.alpha = 0;
        content_View.frame = CGRectMake(0, MAINSCREEN_height, MAINSCREEN_width, MAINSCREEN_height-pointY);
    } completion:^(BOOL finished) {
        [BGView removeFromSuperview];
        [content_View removeFromSuperview];
        BGView=nil;
        content_View=nil;
    }];
}


@end
